(cl:defpackage :std.sequence.list.tree
  (:use)
  (:local-nicknames (:% :std.internal)))
(cl:in-package :std.sequence.list.tree)

(%:fn/macro circular? (object) alexandria:circular-tree-p)
(%:fn/macro copy (object) cl:copy-tree)
;; (%:macro match cl:destructuring-bind)
(%:macro with-let cl:destructuring-bind)
(%:fn/macro flatten (tree) alexandria:flatten)
(%:fn/macro replace (tree old new :key key (test #'cl:eql)) cl:subst)
(%:fn/macro replace! (tree old new :key key (test #'cl:eql)) cl:nsubst)
(%:fn/macro replace-if (tree (test predicate) new :key key) cl:subst-if)
(%:fn/macro replace-if! (tree (test predicate) new :key key) cl:nsubst-if)
(%:fn/macro replace-pairs (tree alist :key key (test #'cl:eql)) cl:sublis)
(%:fn/macro replace-pairs! (tree alist :key key (test #'cl:eql)) cl:nsublis)
(%:fn/macro equal? ((x tree1) (y tree2) :key test) cl:tree-equal)
